import os, info

INFO=info.copy()
INFO['description']=\
"""This is the main SPE application created with SPE and wxGlade."""
__doc__=INFO['doc']%INFO

MDI     = 0
DEBUG   = 0


def main(debug=0):
    #modules
    print """
Starting Spe v%s ...

If spe fails to start:
\t- type "python SPE_.py --debug > debug.txt" at the command prompt
\t- send debug.txt with some info to s_t_a_n_i@yahoo.com

(c)www.stani.be

Importing modules..."""%INFO['version']
    import ConfigParser, sys
    from sm.wxp.smdi import App
    import Menu,Parent,Child
    try:
        import wx
        wxV='.'.join([str(x)for x in wx.VERSION])
        if wxV!=INFO['wxVersion']:
            print '\nSpe Warning: Spe was developped on wxPython v%s, but v%s was found.'%(INFO['wxVersion'],wxV)
            print 'If you experience any problems please install wxPython v%s\n'%INFO['wxVersion']
    except:
        print "Spe Error: Please install the right version of wxPython: %s"%INFO['wxVersion']
        return
    try:
        import Blender
        redraw      = Blender.Redraw
        print 'Blender support enabled.'
    except:
        Blender     = None
        redraw      = None
        print 'Blender support disabled (run Spe from within Blender for Blender support)'
    #openFiles
    openFiles = []
    if debug:
        __debug = debug
    elif 'argv' in dir(sys):
        commandLine = sys.argv[1:]
        __debug=('--debug' in commandLine)
        openFiles   = [x for x in commandLine if x[:2]!= '--']
    else:
        __debug=debug
        openFiles=[]
    if __debug: print 'Spe is running in debugging mode.'
    #preferences
    config=ConfigParser.ConfigParser()
    config.readfp(open(INFO['defaults']))
    try:
        config.read(INFO['defaultsUser'])
    except:
        print 'Spe warning: could not load user options'
    #Mdi
    Mdi = config.get('DEFAULT','Mdi')
    if Mdi == '<default>':
        __mdi = (wx.Platform != "__WXMAC__")
    else:
        __mdi = (Mdi == 'multiple (windows, linux)')
    style = wx.DEFAULT_FRAME_STYLE | wx.VSCROLL | wx.HSCROLL
    try:
        maximize=eval(config.get("DEFAULT","maximize"))
    except:
        maximize=True
    if maximize: style |= wx.MAXIMIZE
    try:
        sizeX=int(config.get("DEFAULT","sizex"))
        sizeY=int(config.get("DEFAULT","sizey"))
        posX=int(config.get("DEFAULT","posx"))
        posY=int(config.get("DEFAULT","posy"))
    except:
        sizeX=800
        sizeY=600
        posX=0
        posY=0
    app = App(Parent.Panel,Child.Panel,Menu.Bar,Menu.Tool,Menu.Status,mdi=__mdi,
        debug=__debug,home='SPE',redraw=redraw,Blender=Blender,openFiles=openFiles,
        size=wx.Size(sizeX,sizeY), config=config,pos=wx.Point(posX,posY),
        imagePath=os.path.join(info.path,'skins','default'),style=style)
    if maximize:
        app.GetTopWindow().Maximize(1)
    app.MainLoop()

if __name__=='__main__':
    main(debug=DEBUG)