#!/usr/bin/env python (see __doc__ for more info________________________________

import info
INFO=info.copy()

INFO['description']=\
"""This will remove spe and all its components (sm*) from your
system. Use this at your own risk. The author is not responsible for any damage
that may occur of using this program."""

__doc__=INFO['doc']%INFO
#_______________________________________________________________________________

def main():
    """Remove spe and all its components (sm*) from your system."""
    try:
        import sm, os, sm.osx, sys
        spebin = os.path.join(sys.prefix, 'bin', 'spe') #Add the startscript for removal too
        path=os.path.dirname(sm.__file__)
        modules=['blenpy','sm_idle','_spe','sm']

        print
        print INFO['description']
        print
        print "These are the paths/files that will be removed:"
        for m in modules: print '\t',path.replace('sm',m)
        if os.path.exists(spebin):
            print '\t', spebin

        answer=raw_input("\nAre you sure you want to continue? (N/y) ").lower()
        if answer=='y':
            print "\nStarting to remove paths..."
            for m in modules:
                try:
                    p=path.replace('sm',m)
                    sm.osx.rmtree(p)
                    print '\t',p, 'succesfully removed'
                except:
                    print '\t',p, 'could not be removed'
            print "\nRemoving wrapper script..."
            try:
                os.remove(spebin)
                print '\t', spebin, 'successfully removed'
            except:
                print '\t', spebin, 'could not be removed'
        else: print "\nSpe uninstallation is cancelled, so spe is not removed."

    except ImportError:
        print "Error: sm module can not be found, but is necessary to uninstall spe."

if __name__=='__main__':
    main()