####(c)www.stani.be-------------------------------------------------------------
MDI=1
SDI=0

try:
    import sm
    INFO=sm.INFO.copy()

    INFO['title']     = INFO['titleFull'] = 'SDI/MDI Framework'

    INFO['description']=\
    """Framework which makes it easy to switch between SDI (Linux/Mac)
    and MDI (Windows).
    """

    __doc__=INFO['doc']%INFO
except:
    __doc__=="Stani's Multiple Document Interface (c)www.stani.be"

"""Todo:
- realize now comes before settoolbar
- check if SetToolBitmapSize has any influence
"""

####Modules & constants
import os, sys
import wx
from wx.lib.evtmgr import eventManager

PARENTFRAME_ID              = wx.NewId()
PARENTFRAME_ID_SASH         = wx.NewId()#MDI only
PARENTFRAME_ID_STATUSBAR    = wx.NewId()
PARENTFRAME_ID_TABS         = wx.NewId()
PARENTFRAME_ID_TOOLBAR      = wx.NewId()
PARENTFRAME_STYLE           = wx.DEFAULT_FRAME_STYLE | wx.MAXIMIZE

TITLE                       = 'www.stani.be'

####Menu helper function
def _strip(x):
    return x.replace(' ','_').replace('-','_').replace('&& ','').replace('&','').replace('.','').replace('(','').replace(')','')

def menuWrite(menuBar,f='menu.txt'):
    labels = []
    for m in range(menuBar.GetMenuCount()):
        menu        = menuBar.GetMenu(m)
        menuLabel   = menuBar.GetLabelTop(m)
        for item in menu.GetMenuItems():
            label   = _strip(item.GetLabel())
            if label:
                labels.append((menuLabel,item.GetLabel()))
    #events
    result = '\tdef __smdi__(self):\n'
    for label in labels:
        label = _strip(label[1])
        result+= '\t\twx.EVT_MENU(self,%s,self.menu_%s)\n'%(label.upper(),label.lower())
    result+= '\n'
    for label in labels:
        result+='\tdef menu_%s(self):\n\t\t"""%s"""\n\t\tpass\n\n'%(_strip(label[1].lower()),'%s > %s'%label)
    print result
    print os.getcwd()
    print f
    f   = open(f,'w')
    f.write(result)
    f.close()

def test_menuWrite():
    import menu
    menuWrite(wxgMenu.Bar())

####Base
WX_BITMAP       = wx.Bitmap

class Bitmap:
    def __init__(self,path,application):
        self.path = path
        self.application = application
    def __call__(self,x,t=wx.BITMAP_TYPE_ANY):
        path = os.path.join(self.path,os.path.basename(x))
        if self.application.DEBUG:
            print 'Bitmap: "%s" opened from "%s"'%(x,path)
        return WX_BITMAP(path,t)

class Framework:
    def __init__(self,**options):
        self.dead = 0
        self.__menu__()
        self.__tool__()
        self.__tabs__()
        self.__panel__(parent=self,**options)
        self.panel.menuBar = self.menuBar
        self.__statusBar__()
        self.Show(True)

    def __menu__(self):
        """Create menubar (to be overwritten)."""
        self.menuBar = None

    def __tabs__(self):
        """Create tabs to switch between documents (to be overwritten)."""
        self.childBook = None

    def __tool__(self):
        """Create menubar (to be overwritten)."""
        self.toolBar = None

    def __panel__(self,**options):
        """Create main panel (to be overwritten)."""
        pass

    def __statusBar__(self):
        """Create statussbar (to be overwritten)."""
        pass

    #---events
    def __events__(self):
        """Initialize events."""
        eventManager.Register(self.onFrameActivate,  wx.EVT_ACTIVATE,    self)
        eventManager.Register(self.onFrameClose,     wx.EVT_CLOSE,       self)
        eventManager.Register(self.onFrameMove,      wx.EVT_MOVE,        self)
        eventManager.Register(self.onFrameSize,      wx.EVT_SIZE,        self)

    def onFrameActivate(self, event=None):
        """To be overwritten."""
        if self.application.DEBUG:
            print 'Event: %s.Activate'%self.__class__
        try:
            if hasattr(self.panel,'onActivate'):
                self.panel.onActivate(event)
            if event: event.Skip()
        except Exception,m:
            if self.application.DEBUG:
                print 'Warning: %s.onFrameActivate failed\n%s\n%s\n'%(self.__class__,Exception,m)


    def onFrameClose(self, event=None, destroy = 1):
        """To be overwritten."""
        if self.application.DEBUG:
            print 'Event: %s.Close'%self.__class__
        if hasattr(self.panel,'onClose'):
            self.dead = self.panel.onClose()
        else:
            self.dead = 1
        if self.dead:
            eventManager.DeregisterWindow(self)
            if destroy: self.Destroy()
            return 1
        else:
            return 0

    def onFrameMove(self, event=None):
        """To be overwritten."""
        if self.application.DEBUG:
            print 'Event: %s.Move'%self.__class__
        if hasattr(self.panel,'onMove'):
            self.panel.onMove(event)
        if event: event.Skip()

    def onFrameSize(self, event=None):
        """To be overwritten."""
        if self.application.DEBUG:
            print 'Event: %s.Size'%self.__class__
        if hasattr(self.panel,'onSize'):
            self.panel.onSize(event)
        if event: event.Skip()

class Tabs:
    def __tabs__(self):
        """Create tabs to switch between documents as an wx.SashLayoutWindow"""
        if self.application.DEBUG:
            print 'Creating %s.tabs'%(self.__class__,)
        self.tabs = wx.SashLayoutWindow(id=PARENTFRAME_ID_TABS,
              name='tabs', parent=self, style=wx.CLIP_CHILDREN)
        self.tabs.SetOrientation(wx.LAYOUT_HORIZONTAL)
        self.tabs.SetAlignment(wx.LAYOUT_TOP)
        platform    = sys.platform
        if self.application.mdi and platform!='win32':
            height = 0
        elif platform == 'win32':
            height = 20
        else:
            height = 30
        self.tabs.SetDefaultSize(wx.Size(792, height))
        self.tabs.Show(1)
        self.tabs.Refresh()
        self.childBook = wx.Notebook(id=-1, parent=self.tabs)
        eventManager.Register(self.onFrameTab, wx.EVT_NOTEBOOK_PAGE_CHANGED, self.childBook)

    def onFrameTab(self,event):
        """When a tab is changed.
        SDI parentFrame has its own one"""
        index = event.GetSelection()
        if self.application.DEBUG:
            print 'Event: %s.onFrameTab(%s)'%(self.__class__,index)
        if self.application.mdi:
            window = self.children[index]
        else:
            if index == 0:
                window = self.parent
            else:
                window = self.children[index-1]
        window.Raise()
        #event.Skip()->never do this

class Parent(Tabs,Framework):
    #---initialize
    def __init__(self,application,**options):
        self.application        = application
        self.children           = []
        self.config             = application.config
        self.parent             = self
        self.options            = options
        Framework.__init__(self)
        self.__smdi__()
        if self.application.mdi: #SM: necessary, but I don't know why
            wx.LayoutAlgorithm().LayoutWindow(self, self.GetClientWindow())
        self.__events__()

    def __smdi__(self):
        #Childframe
        self.ChildFrame     = self.application.ChildFrame
        #parentPanel
        self.parentPanel    = self.menuBar.parentPanel =\
            self.toolBar.parentPanel = self.panel
        #panel
        panel               = self.panel
        panel.application   = self.application
        panel.dead          = 0
        panel.ChildFrame    = self.ChildFrame
        panel.children      = self.children
        panel.config        = self.config
        panel.maximize      = 0
        panel.parent        = self
        panel.SetStatusText = self.SetStatusText
        panel.__smdi__()

    def __menu__(self):
        print """Create menu."""
        #create
        self.menuBar                = self.application.MenuBar()
        self.SetMenuBar(self.menuBar)
        #reference
        self.menuBar.application    = self.application
        self.menuBar.parent         = self

    def __statusBar__(self):
        print """Create statusbar"""
        self.statusBar              = self.application.StatusBar(parent=self,id=-1)
        self.SetStatusBar(self.statusBar)

    def __tool__(self):
        """Create toolbar

        Very important: in the custom wx.ToolBar class after the
        wx.ToolBar.__init__ the following code must be written:
            parent.SetToolBar(self)"""
        toolBarStyle                = wx.TB_HORIZONTAL | wx.NO_BORDER | wx.TB_FLAT | wx.TB_TEXT
##        toolBarStyle                = wx.TB_3DBUTTONS|wx.TB_DOCKABLE
        self.toolBar                = self.application.ToolBar(parent=self,
            id=-1,application=self.application,style=toolBarStyle)
        #self.SetToolBar(self.toolBar)
        #reference
        self.toolBar.application    = self.application
        self.toolBar.parent         = self
        self.toolBar.menuBar        = self.menuBar
        self.menuBar.toolBar        = self.toolBar
        #events
        self.menuBar.__smdi__()
        self.toolBar.__smdi__()

    #---events
    def __events__(self):
        Framework.__events__(self)
        eventManager.Register(self.onFrameIdle, wx.EVT_IDLE, self)

    def onFrameClose(self,event=None):
        dead = Framework.onFrameClose(self,event,destroy=0)
##        if dead:
##            for child in self.children:
##                child.dead = 1
##                eventManager.DeregisterWindow(child.GetParent())
        if dead: self.Destroy()

    def onFrameIdle(self, event):
        """To be overwritten."""
        if not self.dead:
            if 'onIdle' in dir(self.panel):
                self.panel.onIdle()
            event.Skip()

    #---menu
    def menu_new(self, event=None):
        self.child()

    def menu_close(self,event=None):
        childActive = self.panel.childActive
        if childActive:
            childActive.onFrameClose()

    #---parentPanel
    def child(self,*args,**keyw):
        self.ChildFrame(self,*args,**keyw)

    def maximize(self):
        i = 0
        m = 0
        while i<len(self.children) and not m:
            m   = self.children[i].GetParent().IsMaximized()
            i   += 1
        return m

class Child(Framework):
    #---initialize
    def __init__(self,parent,name='unnamed',**options):
        self.application        = parent.application
        self.childBook          = parent.childBook
        self.children           = parent.children
        self.parent             = parent
        self.parentPanel        = panel     = parent.panel
        #name='%s (%s)'%(name,len(self.parent.panel.children))
        Framework.__init__(self,**options)
        self.name               = name
        self.__smdi__()
        self.__events__()

    def __smdi__(self):
        #panel
        panel                   = self.panel
        panel.application       = self.application
        panel.childBook         = self.childBook
        panel.children          = self.children
        panel.dead              = 0
        panel.getIndex          = self.getIndex
        panel.getIndexSmdi      = self.getIndexSmdi
        if self.menuBar:
            panel.menuBar       = self.menuBar
            panel.toolBar       = self.toolBar
            panel.SetStatusText = self.SetStatusText
        else:
            panel.menuBar       = self.parent.menuBar
            panel.toolBar       = self.parent.toolBar
            panel.SetStatusText = self.parent.SetStatusText
        panel.parent            = self.parent
        panel.parentPanel       = self.parentPanel
        panel.Raise             = self.Raise
        panel.SetIcon           = self.SetIcon
        panel.SetTitle          = self.SetTitle
        panel.name              = self.name
        #events
        panel.onFrameActivate   = self.onFrameActivate
        panel.onFrameClose      = self.onFrameClose
        panel.onFrameMove       = self.onFrameMove
        panel.onFrameSize       = self.onFrameSize
        panel.__smdi__()
        #children
        self.children.append(self.panel)
        self.parent.childBook.AddPage(page=wx.Panel(id=-1,parent=self.parent.childBook,size=wx.Size(0,0)),
            text=self.name,select=self.application.mdi)
        self.parentPanel.childActive   = self.panel
        if not self.application.mdi:
            wx.LayoutAlgorithm().LayoutWindow(self, panel)

    def __panel__(self,**kwds):
        """Create main panel."""
        self.panel = self.application.ChildPanel(id=-1, name='childPanel', **kwds)


    #---events
    def onFrameActivate(self, event = None):
        """Activate event."""
        if self.application.DEBUG:
            'Event: %s.Activate'%self.__class__
        Framework.onFrameActivate(self)
        self.parentPanel.childActive   = self.panel
        index                          = self.getIndex()
        try:
            if self.application.mdi:
                self.parent.childBook.SetSelection(index)
            else:
                self.childBook.SetSelection(index+1)
            event.Skip()
        except Exception,m:
            if self.application.DEBUG:
                print 'Warning: %s.onFrameActivate failed\n%s\n%s\n'%(self.__class__,Exception,m)


    def onFrameClose(self, event = None, destroy = 1):
        """Close event."""
        if self.application.DEBUG:
            print 'Event: %s.Close'%self.__class__
        index = self.getIndex()
        dead = Framework.onFrameClose(self,destroy=0)
        if dead:
            if self.application.mdi:   delta = 0
            else:                      delta = 1
            if index+1:
                try: #SM:01-05-04:no idea why this is necessary?
                    if self.application.DEBUG:
                        print 'If spe crashes here, please upgrade your version of wxPython.'
                    self.parent.childBook.DeletePage(index+delta)
                except:
                    pass
                eventManager.DeregisterWindow(self)
                for child in self.children:
                    if child.dead:
                        self.children.remove(child)
                if self.childBook:
                    c       = 1
                    current = index+delta
                    for child in self.children:
                        childBook = child.childBook
                        childBook.DeletePage(current)#remove closed item from other children
                        if c>=current:
                            childBook.SetSelection(c)#adapt selection
                        childBook.Refresh()
                        c += 1
                if self.children:
                    self.children[max(0,index-1)].Raise()
                else:
                    self.parent.childActive = None
                if destroy: self.Destroy()
            return 1
        else:
            return 0

    #---parentPanel
    def getIndex(self):
        """Get index of current child."""
        if self.panel in self.children:
            return self.children.index(self.panel)
        else:
            return -1

    def getIndexSmdi(self):
        if self.application.mdi:   return self.getIndex()
        else:                      return self.getIndex() + 1


####Splitted classes


#---Parent

class MDIParentFrame(Parent,wx.MDIParentFrame):
    """Uniformed parent MDI/SDI class based on MDI.

    self.Panel is defined by joined class"""
    def __init__(self,application,
            id      = PARENTFRAME_ID,
            name    = 'parentFrame',
            parent  = None,
            size    = wx.Size(600,400),
            style   = PARENTFRAME_STYLE,
            title   = TITLE,
            pos     = wx.Point(10,10),
            **options):
        self.application    = application
        self.size           = size
        wx.MDIParentFrame.__init__(self,
            id      = id,
            name    = name,
            parent  = parent,
            size    = wx.Size(800,600),
            style   = style,
            title   = title,
            pos     = pos)
        self.SetAutoLayout(0)
        self.SetClientSize(wx.Size(900, 700))
        try:
            self.Move((-1,-1))
        except:
            pass
        try: #not working on mandrake9
            if style & wx.MAXIMIZE:
                self.Maximize(1)
            else:
                self.SetSize(size)
        except:
            self.SetSize(size)
        Parent.__init__(self,application,**options)

    def __panel__(self,**options):
        #sash
        self.sash = wx.SashLayoutWindow(id=PARENTFRAME_ID_SASH,
              name='sash', parent=self, style=wx.CLIP_CHILDREN)
        self.sash.SetOrientation(wx.LAYOUT_HORIZONTAL)
        self.sash.SetAlignment(wx.LAYOUT_BOTTOM)
        self.sash.SetDefaultSize(wx.Size(792, 200))
        self.sash.SetSashVisible(wx.SASH_TOP, 1)
        self.sash.Show(1)
        self.sash.SetMinimumSizeY(1)
        eventManager.Register(self.onFrameSashDragged, wx.EVT_SASH_DRAGGED, self.sash)
        #panel
        self.panel          = self.application.ParentPanel(id=-1, name='parentPanel', parent=self.sash,**self.options)
        self.panelSizer     = wx.BoxSizer(wx.VERTICAL)
        self.panelSizer.Add(self.panel, 1, wx.ALL | wx.EXPAND, 0)
        self.sash.SetAutoLayout(1)
        self.sash.SetSizer(self.panelSizer)

    #---events
    def onFrameSashDragged(self,event):
        """Called when the shashwindow is dragged."""
        if event.GetDragStatus() == wx.SASH_STATUS_OUT_OF_RANGE:
            return
        eID = event.GetId()
        if eID == PARENTFRAME_ID_SASH:
            self.sash.SetDefaultSize(wx.Size(1000,event.GetDragRect().height))
        wx.LayoutAlgorithm().LayoutMDIFrame(self)
        self.GetClientWindow().Refresh()

    def onFrameSize(self, event):
        """Overwritten for sash dragging."""
        Framework.onFrameSize(self)
        wx.LayoutAlgorithm().LayoutMDIFrame(self)

class SDIParentFrame(Parent,wx.Frame):
    """Uniformed parent MDI/SDI class based on SDI."""
    def __init__(self,application,
            id      = -1,
            name    = 'parentFrame',
            parent  = None,
            size    = wx.Size(600,400),
            style   = PARENTFRAME_STYLE,
            title   = TITLE,
            pos     = wx.Point(10,10),
            **options):
        self.application = application
        self.size        = size
        wx.Frame.__init__(self,
            id      = id,
            name    = name,
            parent  = parent,
            size    = wx.Size(600,400),
            style   = style,
            title   = title,
            pos     = pos)
        Parent.__init__(self,application,**options)
        try: #not working on mandrake9
            if style & wx.MAXIMIZE:
                self.Maximize(1)
            else:
                self.SetSize(size)
        except:
            self.SetSize(size)

    def __panel__(self,**options):
        self.childBook.AddPage(page=wx.Panel(id=-1,parent=self.childBook),text=self.application.home)
        self.panel = self.application.ParentPanel(id=-1, parent=self,**self.options)
        wx.LayoutAlgorithm().LayoutWindow(self,self.panel)
        self.panel.Refresh()
    #---events
    def onFrameActivate(self,event):
        try:
            Framework.onFrameActivate(self)
            self.childBook.SetSelection(0)
            self.childBook.Refresh()
        except Exception,m:
            if self.application.DEBUG:
                print 'Warning: %s.onFrameActivate failed\n%s\n%s\n'%(self.__class__,Exception,m)

    def onFrameSize(self, event):
        """Overwritten for sash dragging."""
        wx.LayoutAlgorithm().LayoutWindow(self, self.panel)

#---Child
class MDIChildFrame(Child,wx.MDIChildFrame):
    def __init__(self,parent,
        id          = -1,
        name        = 'unnamed',
        style       = wx.DEFAULT_FRAME_STYLE,
        title       = TITLE,
        **options):
        maximize    = parent.maximize()
        if parent.application.DEBUG:
            print 'Creating %s'%self.__class__
        wx.MDIChildFrame.__init__(self,
            id      = id,
            name    = name,
            parent  = parent,
            style   = style,
            title   = title)
        self.Raise  = self.Activate #raise doesn't work here
        Child.__init__(self,parent,name,**options)
        if maximize:
            self.Maximize()

class SDIChildFrame(Tabs,Child,wx.Frame):
    def __init__(self,parent,
        id          = -1,
        name        = 'unnamed',
        style       = wx.DEFAULT_FRAME_STYLE,
        title       = TITLE,
        **options):
        if parent.application.DEBUG:
            print 'Creating %s'%self.__class__,name,title
        wx.Frame.__init__(self,
            id      = id,
            name    = name,
            parent  = parent,
            size    = wx.Size(600,400),
            style   = style,
            title   = title)
        Child.__init__(self,parent=parent,name=name,**options)
        self.SetSize(parent.size)

    #---initialize
    def __smdi__(self):
        Child.__smdi__(self)
        #menuBar
        self.menuBar.application    = self.parent.application
        self.menuBar.parent         = self
        self.menuBar.parentPanel    = self.parent.panel
        self.menuBar.toolBar        = self.toolBar
        #toolBar
        self.toolBar.application    = self.parent.application
        self.toolBar.parent         = self
        self.toolBar.parentPanel    = self.parent.panel
        self.toolBar.menuBar        = self.menuBar
        #events
        self.menuBar.__smdi__()
        self.toolBar.__smdi__()
        #children
        childBook = self.childBook
        childBook.AddPage(page=wx.Panel(id=-1,parent=self.childBook),text=self.application.home)
        for child in self.children[:-1]:
            child.childBook.AddPage(page=wx.Panel(id=-1,parent=child.childBook),text=self.name)
            childBook.AddPage(page=wx.Panel(id=-1,parent=childBook),text=child.name)
        childBook.AddPage(page=wx.Panel(id=-1,parent=childBook),text=self.name,select=True)

    def __menu__(self):
        """Create menu."""
        self.menuBar   = self.application.MenuBar()
        self.SetMenuBar(self.menuBar)

    def __statusBar__(self):
        self.statusBar = self.application.StatusBar(parent=self,id=-1)
        self.SetStatusBar(self.statusBar)


    def __tool__(self):
        """Create toolbar."""
        self.toolBar   = self.application.ToolBar(parent=self,id=-1,application=self.application)
        self.SetToolBar(self.toolBar)

    def __panel__(self,**options):
        self.panel = self.application.ChildPanel(id=-1, name='childPanel', **options)
        wx.LayoutAlgorithm().LayoutWindow(self,self.panel)
        self.panel.Refresh()


    #---events
    def onFrameSize(self, event):
        """Overwritten for sash dragging."""
        Framework.onFrameSize(self)
        wx.LayoutAlgorithm().LayoutWindow(self, self.panel)

    def onFrameTab(self,event):
        try:
            index = event.GetSelection()
            if self.application.DEBUG:
                print 'Event: %s.onFrameTab(%s) SDI'%(self.__class__,index)
            if index == 0:
                self.parent.Raise()
            else:
                self.children[index-1].Raise()
        except:
            self.children[event.GetSelection()-1].Raise()
        #event.Skip()

####Application

class App(wx.App):
    def __init__(self, ParentPanel, ChildPanel, MenuBar, ToolBar, StatusBar,
            mdi=0, debug=0, home='Home',config=None,size=wx.Size(800,600),
            imagePath = None, pos=wx.Point(10,10),
            style=wx.DEFAULT_FRAME_STYLE | wx.VSCROLL | wx.HSCROLL,**options):
        self.MenuBar        = MenuBar
        self.ParentPanel    = ParentPanel
        self.ChildPanel     = ChildPanel
        self.ToolBar        = ToolBar
        self.StatusBar      = StatusBar
        self.home           = home
        self.config         = config
        self.size           = size
        self.imagePath      = imagePath
        self.pos            = pos
        self.style          = style
        if self.imagePath:
            self.bitmap     = wx.Bitmap = Bitmap(imagePath,self)
        else:
            self.bitmap     = wx.Bitmap
        self.SetMdi(mdi)
        self.DEBUG          = debug
        options['redirect'] = not debug
        self.options        = options
        wx.App.__init__(self,redirect=0)

    def OnInit(self):
        wx.InitAllImageHandlers()
        self.main = self.ParentFrame(self,size=self.size,pos=self.pos,
            style=self.style,**self.options)
        self.main.Show(True)
        self.SetTopWindow(self.main)
        return True

    def SetMdi(self,mdi=0):
        self.mdi    = mdi
        if mdi:
            self.ParentFrame    = MDIParentFrame
            self.ChildFrame     = MDIChildFrame
        else:
            self.ParentFrame    = SDIParentFrame
            self.ChildFrame     = SDIChildFrame


class MenuBar:
    def __init__(self,parent,*args,**kwds):
        """
        Parameters:
            parent  = parent frame
            parentPanel = parent panel, which has the menu methods"""
        self.parent     = parent


class TestMenuBar(wx.MenuBar):
    def __init__(self,*args,**kwds):
        wx.MenuBar.__init__(self,*args,**kwds)
        self.file   = wx.Menu()
        self.NEW    = wx.NewId()
        self.CLOSE  = wx.NewId()
        self.EXIT   = wx.NewId()
        self.file.Append(self.NEW, "&New\tCtrl+N", "", wx.ITEM_NORMAL)
        self.file.Append(self.CLOSE, "&Close\tCtrl+F4", "", wx.ITEM_NORMAL)
        self.file.Append(self.EXIT, "&Exit\tAlt+F4", "", wx.ITEM_NORMAL)
        self.Append(self.file, "&File")
    def __smdi__(self):
        wx.EVT_MENU(self.parent,self.NEW,self.menu_new)
        wx.EVT_MENU(self.parent,self.CLOSE,self.menu_close)
        wx.EVT_MENU(self.parent,self.EXIT,self.menu_exit)
    def menu_new(self,event=None):
        self.parentPanel.new()
    def menu_close(self,event=None):
        self.parentPanel.close()
    def menu_exit(self,event=None):
        self.parent.Destroy()

ArtIDs = [ wx.ART_FILE_OPEN,
           wx.ART_PRINT,
           wx.ART_ADD_BOOKMARK,
           wx.ART_REPORT_VIEW,
           wx.ART_LIST_VIEW,
           wx.ART_HELP,
           ]

class TestToolBar(wx.ToolBar):
    def __init__(self,parent=None,id=-1,menu=None,application=None,**kwds):
        print 'creating toolbar'
        self.application = application
        wx.ToolBar.__init__(self,parent=parent,id=id,**kwds)
        parent.SetToolBar(self)
        self.tools = []
        for id in ArtIDs:
            toolId = wx.NewId()
            bmp = wx.ArtProvider_GetBitmap(id, wx.ART_TOOLBAR, (16,16))
            self.AddLabelTool(toolId, "", bmp, wx.NullBitmap, wx.ITEM_NORMAL, "info", "")
            self.tools.append(toolId)
        self.Realize()
    def __smdi__(self):
        for id in self.tools:
            wx.EVT_TOOL(self,id, self.test)
    def test(self,event):
        print 'test seems ok'

class TestParentPanel(wx.TextCtrl):
    def __init__(self,parent,redirect,**kwds):
        wx.TextCtrl.__init__(self,value='parent',parent=parent,**kwds)
    def __smdi__(self):
        pass
    def new(self):
        self.ChildFrame(self.parent)
    def close(self,event):
        self.childActive.onFrameClose()

class TestChildPanel(wx.TextCtrl):
    def __init__(self,parent,**kwds):
        wx.TextCtrl.__init__(self,value='child',parent=parent,**kwds)
    def __smdi__(self):
        pass

def __test__(debug):
    app = App(TestParentPanel, TestChildPanel, TestMenuBar, TestToolBar, wx.StatusBar, mdi=MDI, home='Parent', debug=debug)
    app.MainLoop()

if __name__=='__main__': __test__(debug=1)

